$(document).ready(function ()
{
    InitGrid();
    $("#domainsSave").igButton({ labelText: $("#domainsSave").val(), disabled: true });
});

function InitGrid()
{
    $("#domainsSave").igButton({ labelText: $("#domainsSave").val(), disabled: true });

    $("#grid").igGrid({
        autoGenerateColumns: false,
        primaryKey: "ProductID",
        autoCommit: true,
        width: "100%",
        renderCheckboxes: true,
        height: "400px",
        columns: [
                    { headerText: "Product ID", key: "ProductID", dataType: "number", width: "25%" },
                    { headerText: "Product Name", key: "Name", dataType: "string", width: "30%" },
                    { headerText: "Product Number", key: "ProductNumber", dataType: "string", width: "20%" },
                    { headerText: "Make Flag", key: "MakeFlag", dataType: "bool", width: "25%" }
                ],
        dataSource: adventureWorks,
        features: [
                    {
                        name: "Updating"
                    },
                    {
                        name: "Summaries",
                        summariesCalculated: function (evt, ui)
                        {
                            var trueValues = ui.owner.summaryCollection().MakeFlag[0].result;
                            var falseValues = ui.owner.summaryCollection().MakeFlag[1].result;
                            var total = trueValues + falseValues;

                            $("#resultSpan").text("There are " + trueValues + " checked rows from " + total);


                            if (trueValues >= 242) {
                                $("#validatorSpan").show();
                                $('#domainsSave').igButton('option', 'disabled', true);
                                alert("limit reached - save button disabled");
                            }
                            else {
                                $("#validatorSpan").hide();
                                $('#domainsSave').igButton('option', 'disabled', false);
                            }


                            $("tr[data-role='summaryrow']").each(function (index)
                            {
                                $(this).hide();
                            });

                        },
                        columnSettings: [
                            {
                                columnIndex: 0, allowSummaries: false
                            },
                             {
                                 columnIndex: 1, allowSummaries: false
                             },
                              {
                                  columnIndex: 2, allowSummaries: false
                              },
                            {
                                columnKey: "MakeFlag",
                                summaryOperands: [
                                    {
                                        rowDisplayLabel: "Count True Values",
                                        type: "custom1",
                                        summaryCalculator: $.proxy(countTrueValues, this),
                                        order: 5
                                    },
                                    {
                                        rowDisplayLabel: "Count False Values",
                                        type: "custom2",
                                        summaryCalculator: $.proxy(countFalseValues, this),
                                        order: 6
                                    }
                                ]
                            }
                        ]
                    }
                ]
    });

    InitButtons();
}



function InitButtons()
{
    try {
        grid = $("#grid");

        $("#domainsSave").igButton({ labelText: $("#domainsSave").val(), disabled: true });
        //$("#domainsSave").on('igbuttonclick', OnDomainsSaveChangesClick);

        grid.on("iggridupdatingeditrowended", function (e, args)
        {
            if (args.update) {
                $("#domainsSave").igButton("option", "disabled", false);
                alert('save button enabled');

            }
        });
    }
    catch (e) {
        alert(e);
    }
}

function countTrueValues(data)
{
    var i, l = data.length, count = 0, elem;
    for (i = 0; i < l; i++) {
        elem = data[i];
        if (elem === true) {
            count++;
        }
    }
    return count;
}

function countFalseValues(data)
{
    var i, l = data.length, count = 0, elem;
    for (i = 0; i < l; i++) {
        elem = data[i];
        if (elem === false) {
            count++;
        }
    }
    return count;
}
